#!/usr/bin/python3

import socket
from subprocess import PIPE, Popen
import time

ADDR = 'fe80::ec0b:fb0f:76b9:f393' # the other RPi
PORT = 2016

def get_cpu_temperature():
    process = Popen(['vcgencmd', 'measure_temp'], stdout=PIPE)
    output, _error = process.communicate()
    return output

def main():
    scope_id = socket.if_nametoindex('lowpan0')
    while True:
        s6 = socket.socket(socket.AF_INET6, socket.SOCK_DGRAM, 0)
        s6.sendto(get_cpu_temperature(), (ADDR, PORT, 0, scope_id))
        s6.close()
        time.sleep(10)

if __name__ == '__main__':
    main()
