#!/usr/bin/env python3

import asyncio

import aiocoap
from aiocoap import *
import cbor
import time

CONTENT_FORMAT_CBOR = 60

@asyncio.coroutine
def main():
    protocol = yield from Context.create_client_context()
    #client = asyncio.get_event_loop().run_until_complete(aiocoap.Context.create_client_context())

    #request = Message(code=GET)
    #request.set_request_uri('coap://[fd28::2]/.well-known/core')

    #try:
    #    response = yield from protocol.request(request).response
    #except Exception as e:
    #    print('Failed to fetch resource:')
    #    print(e)
    #else:
    #    print('Result: %s\n%s'%(response.code,
    #                            response.payload.decode('utf-8')))

    
    request = Message(code=GET)
    request.set_request_uri('coap://[fd28::2]/temperature')
    request.opt.observe = 0
    #request.opt.token = 0x4a

    requester = protocol.request(request)
    #requester = client.request(request)
    observation_results = []
    #requester.observation.register_callback(lambda message: observation_results.append(message.payload))
    requester.observation.register_callback(lambda message: print(message.payload))


    
    try:
        #response = yield from protocol.request(request).response
        response = yield from requester.response
    except Exception as e:
        print('Failed to fetch resource:')
        print(e)
    else:
        if response.opt.content_format == CONTENT_FORMAT_CBOR:
            print('Result: %s\n%r'%(response.code,
                                    cbor.loads(response.payload)))
        else:
            print('Unknown format')


    #asyncio.get_event_loop().run_until_complete(requester.response)
    # print(requester.app_request.opt)
    #async for i in requester.observation:
    #    print('Got another')
    time.sleep(200)
        
if __name__ == "__main__":
    asyncio.get_event_loop().run_until_complete(main())
    #main()
